-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
local rearMotor = powertrain.getDevice("rearMotor")
local ThrusterForwardNode = "propm1"
local decreaseThrust = true
local nodeID

local function reset()
    electrics.values.boost_forward = 0
    electrics.values.boost_steer_left = 0
    electrics.values.boost_steer_right = 0
end

local function updateGFX(dt)
    if decreaseThrust == false then
        if rearMotor.motorDirection == 1 then -- 1 is D; 0 is N; -1 is R
            electrics.values.boost_forward = electrics.values.throttle
        elseif rearMotor.motorDirection == 0 then -- 1 is D; 0 is N; -1 is R
            electrics.values.boost_forward = 0
        elseif rearMotor.motorDirection == -1 then -- 1 is D; 0 is N; -1 is R
            electrics.values.boost_forward = electrics.values.throttle * -1
        end
    elseif decreaseThrust == true then
        if rearMotor.motorDirection == 1 then -- 1 is D; 0 is N; -1 is R
            electrics.values.boost_forward = electrics.values.throttle * 0.3
        elseif rearMotor.motorDirection == 0 then -- 1 is D; 0 is N; -1 is R
            electrics.values.boost_forward = 0
        elseif rearMotor.motorDirection == -1 then -- 1 is D; 0 is N; -1 is R
            electrics.values.boost_forward = electrics.values.throttle * -0.3
        end
    else
        electrics.values.boost_forward = 0
    end

    if obj:inWater(rearMotor.thrusterTurnOffNodes[nodeID]) then
        decreaseThrust = false
    else
        decreaseThrust = true
        custom_input.disable_thruster_up()
    end
    
    if electrics.values.throttle >= 0.1 and rearMotor.motorDirection == 1 then
        electrics.values.boost_steer_left = electrics.values.steering * -1
        electrics.values.boost_steer_right = electrics.values.steering
    elseif electrics.values.throttle >= 0.1 and rearMotor.motorDirection == -1 then
        electrics.values.boost_steer_left = electrics.values.steering
        electrics.values.boost_steer_right = electrics.values.steering * -1
    end
end

local function init()
    ThrusterForwardNode = "n14"
    rearMotor.thrusterTurnOffNodes = {}
    for v, node in pairs (v.data.nodes) do
		if node.name == ThrusterForwardNode then
            rearMotor.thrusterTurnOffNodes[node]=v
		    nodeID = node
		end
	end
    decreaseThrust = true
end

M.init = init
M.reset = reset
M.updateGFX = updateGFX

return M