-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local isSonar = false
local sonarLoopName = nil
local sonarLoop = nil
local sonarVolume = 1
local tick = 0
local soundNode = 0

local function init(jbeamData)
  sonarLoopName = jbeamData.sonarLoopName or "art/sound/sonar/sonar_ping.flac"
  sonarVolume = jbeamData.sonarVolume or 20

  isSonar = false

  if jbeamData.soundNode_nodes and type(jbeamData.soundNode_nodes) == "table" and type(jbeamData.soundNode_nodes[1]) == "number" then
    soundNode = jbeamData.soundNode_nodes[1]
  else
    soundNode = 0
  end
end

local function updateGFX(dt)
  if electrics.values.sonar == 1 then
    obj:queueGameEngineLua('local camObj = getCamera()   camObj = (camObj and Sim.upcast(camObj)) or camObj   if (camObj and camObj:isCameraUnderwater() and 1) then be:getPlayerVehicle(0):queueLuaCommand("camIsUnderwater = true") else be:getPlayerVehicle(0):queueLuaCommand("camIsUnderwater = false") end') --whacky check if camera is underwater
    if camIsUnderwater == true then
      obj:setVolume(sonarLoop, sonarVolume)
      obj:playSFX(sonarLoop)
      isSonar = true
    elseif isSonar or camIsUnderwater == false then
        obj:cutSFX(sonarLoop)
        obj:stopSFX(sonarLoop)
        isSonar = false
    elseif camIsUnderwater == false then
      obj:setVolume(sonarLoop, 0)
    end
  elseif electrics.values.sonar == 0 then
    obj:cutSFX(sonarLoop)
    obj:stopSFX(sonarLoop)
  end
end

local function reset()
  isSonar = false
  tick = 0
end

local function initSounds()
  sonarLoop = obj:createSFXSource2(sonarLoopName, "AudioLoop2D", "sonarPing", soundNode, 0)
end

M.init = init
M.initSounds = initSounds
M.reset = reset
M.updateGFX = updateGFX

return M