-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local function onReset()
  electrics.values['planes_up'] = 0
  electrics.values['planes_up_input'] = 0
  electrics.values['planes_down'] = 0
  electrics.values['planes_down_input'] = 0

  electrics.values['thruster_up'] = 0
  electrics.values['thruster_up_input'] = 0
  electrics.values['thruster_down'] = 0
  electrics.values['thruster_down_input'] = 0

  gui.message("Mod source: beamng.com/forums.  Made by DaddelZeit. Do not reupload to other sites.")
end

local function updateGFX(dt)
  electrics.values['planes_up'] = math.min(1, math.max(-0.0, (electrics.values['planes_up'] + electrics.values['planes_up_input'] * dt * 0.2)))
  electrics.values['planes_down'] = math.min(1, math.max(-0.0, (electrics.values['planes_down'] + electrics.values['planes_down_input'] * dt * 0.2)))
  electrics.values['thruster_up'] = math.min(1, math.max(-0.0, (electrics.values['thruster_up'] + electrics.values['thruster_up_input'] * dt * 0.2)))
  electrics.values['thruster_down'] = math.min(1, math.max(-0.0, (electrics.values['thruster_down'] + electrics.values['thruster_down_input'] * dt * 0.2)))
end

local function disable_thruster_up()
  electrics.values.planes_up_input = 0
end

local function thruster_up(value)
  electrics.values.thruster_down = 0
  electrics.values.thruster_up_input = value
end

local function thruster_down(value)
  electrics.values.thruster_up = 0
  electrics.values.thruster_down_input = value
end

local function planes_up(value)
  electrics.values.planes_down_input = (value * -1)
  electrics.values.planes_up_input = value
end

local function planes_down(value)
  electrics.values.planes_up_input = (value * -1)
  electrics.values.planes_down_input = value
end

-- public interface
M.onInit = onReset
M.onReset = onReset
M.updateGFX = updateGFX
M.planes_up = planes_up
M.planes_down = planes_down
M.disable_thruster_up = disable_thruster_up
M.thruster_up = thruster_up
M.thruster_down = thruster_down

return M
